Index: trunk/i18n/en.ts
===================================================================
--- trunk/i18n/en.ts	(revision 29)
+++ trunk/i18n/en.ts	(revision 30)
@@ -4,18 +4,57 @@
 <defaultcodec>UTF-8</defaultcodec>
 <context>
-    <name></name>
-    <message>
-        <location filename="../src/mainwindow.cpp" line="244"/>
-        <location filename="../src/mainwindow.cpp" line="253"/>
+    <name>CTSPModel</name>
+    <message>
+        <location filename="../src/tspmodel.cpp" line="52"/>
+        <source>City %1</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/tspmodel.cpp" line="54"/>
+        <source>%1</source>
+        <translation type="unfinished"></translation>
+    </message>
+</context>
+<context>
+    <name>MainWindow</name>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="125"/>
+        <location filename="../src/mainwindow.cpp" line="246"/>
+        <location filename="../src/mainwindow.cpp" line="255"/>
         <source>Language change</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="244"/>
+        <location filename="../src/mainwindow.cpp" line="125"/>
+        <source>Unable to load translation language.</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="192"/>
+        <source>Data error</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="192"/>
+        <source>Error in cell [Row %1; Column %2]: Invalid data format.</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="201"/>
+        <source>Solution error</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="201"/>
+        <source>There was an error while solving the task.</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="246"/>
         <source>Language will be autodetected on next application start.</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="253"/>
+        <location filename="../src/mainwindow.cpp" line="255"/>
         <source>You have language autodetection turned on.
 It needs to be off.
@@ -23,50 +62,4 @@
         <translation type="unfinished"></translation>
     </message>
-</context>
-<context>
-    <name>CTSPModel</name>
-    <message>
-        <location filename="../src/tspmodel.cpp" line="52"/>
-        <source>City %1</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../src/tspmodel.cpp" line="54"/>
-        <source>%1</source>
-        <translation type="unfinished"></translation>
-    </message>
-</context>
-<context>
-    <name>MainWindow</name>
-    <message>
-        <location filename="../src/mainwindow.cpp" line="122"/>
-        <source>Language change</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../src/mainwindow.cpp" line="122"/>
-        <source>Unable to load translation language.</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../src/mainwindow.cpp" line="189"/>
-        <source>Data error</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../src/mainwindow.cpp" line="189"/>
-        <source>Error in cell [Row %1; Column %2]: Invalid data format.</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../src/mainwindow.cpp" line="198"/>
-        <source>Solution error</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../src/mainwindow.cpp" line="198"/>
-        <source>There was an error while solving the task.</source>
-        <translation type="unfinished"></translation>
-    </message>
     <message>
         <location filename="../ui/mainwindow.ce.ui" line="17"/>
@@ -178,19 +171,7 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="302"/>
-        <location filename="../ui/mainwindow.ui" line="283"/>
+        <location filename="../ui/mainwindow.ce.ui" line="308"/>
+        <location filename="../ui/mainwindow.ui" line="289"/>
         <source>&amp;Help</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="342"/>
-        <location filename="../ui/mainwindow.ui" line="355"/>
-        <source>Solution st&amp;eps</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="345"/>
-        <location filename="../ui/mainwindow.ui" line="358"/>
-        <source>Save solution steps</source>
         <translation type="unfinished"></translation>
     </message>
@@ -198,17 +179,17 @@
         <location filename="../ui/mainwindow.ce.ui" line="348"/>
         <location filename="../ui/mainwindow.ui" line="361"/>
+        <source>Solution st&amp;eps</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="351"/>
+        <location filename="../ui/mainwindow.ui" line="364"/>
+        <source>Save solution steps</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="354"/>
+        <location filename="../ui/mainwindow.ui" line="367"/>
         <source>Save solution steps only</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="356"/>
-        <location filename="../ui/mainwindow.ui" line="369"/>
-        <source>Solution &amp;graph</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="359"/>
-        <location filename="../ui/mainwindow.ui" line="372"/>
-        <source>Save solution graph</source>
         <translation type="unfinished"></translation>
     </message>
@@ -216,17 +197,17 @@
         <location filename="../ui/mainwindow.ce.ui" line="362"/>
         <location filename="../ui/mainwindow.ui" line="375"/>
+        <source>Solution &amp;graph</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="365"/>
+        <location filename="../ui/mainwindow.ui" line="378"/>
+        <source>Save solution graph</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="368"/>
+        <location filename="../ui/mainwindow.ui" line="381"/>
         <source>Save solution graph only</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="370"/>
-        <location filename="../ui/mainwindow.ui" line="383"/>
-        <source>&amp;Solution</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="373"/>
-        <location filename="../ui/mainwindow.ui" line="386"/>
-        <source>Save solution</source>
         <translation type="unfinished"></translation>
     </message>
@@ -234,17 +215,17 @@
         <location filename="../ui/mainwindow.ce.ui" line="376"/>
         <location filename="../ui/mainwindow.ui" line="389"/>
+        <source>&amp;Solution</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="379"/>
+        <location filename="../ui/mainwindow.ui" line="392"/>
+        <source>Save solution</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="382"/>
+        <location filename="../ui/mainwindow.ui" line="395"/>
         <source>Save solution steps and graph</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="385"/>
-        <location filename="../ui/mainwindow.ui" line="398"/>
-        <source>&amp;New</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="388"/>
-        <location filename="../ui/mainwindow.ui" line="401"/>
-        <source>New</source>
         <translation type="unfinished"></translation>
     </message>
@@ -252,5 +233,5 @@
         <location filename="../ui/mainwindow.ce.ui" line="391"/>
         <location filename="../ui/mainwindow.ui" line="404"/>
-        <source>New task</source>
+        <source>&amp;New</source>
         <translation type="unfinished"></translation>
     </message>
@@ -258,5 +239,5 @@
         <location filename="../ui/mainwindow.ce.ui" line="394"/>
         <location filename="../ui/mainwindow.ui" line="407"/>
-        <source>Create new task</source>
+        <source>New</source>
         <translation type="unfinished"></translation>
     </message>
@@ -264,17 +245,17 @@
         <location filename="../ui/mainwindow.ce.ui" line="397"/>
         <location filename="../ui/mainwindow.ui" line="410"/>
+        <source>New task</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="400"/>
+        <location filename="../ui/mainwindow.ui" line="413"/>
+        <source>Create new task</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="403"/>
+        <location filename="../ui/mainwindow.ui" line="416"/>
         <source>Ctrl+N</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="409"/>
-        <location filename="../ui/mainwindow.ui" line="422"/>
-        <source>&amp;Open...</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="412"/>
-        <location filename="../ui/mainwindow.ui" line="425"/>
-        <source>Open...</source>
         <translation type="unfinished"></translation>
     </message>
@@ -282,5 +263,5 @@
         <location filename="../ui/mainwindow.ce.ui" line="415"/>
         <location filename="../ui/mainwindow.ui" line="428"/>
-        <source>Open task</source>
+        <source>&amp;Open...</source>
         <translation type="unfinished"></translation>
     </message>
@@ -288,5 +269,5 @@
         <location filename="../ui/mainwindow.ce.ui" line="418"/>
         <location filename="../ui/mainwindow.ui" line="431"/>
-        <source>Open saved task</source>
+        <source>Open...</source>
         <translation type="unfinished"></translation>
     </message>
@@ -294,17 +275,17 @@
         <location filename="../ui/mainwindow.ce.ui" line="421"/>
         <location filename="../ui/mainwindow.ui" line="434"/>
+        <source>Open task</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="424"/>
+        <location filename="../ui/mainwindow.ui" line="437"/>
+        <source>Open saved task</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="427"/>
+        <location filename="../ui/mainwindow.ui" line="440"/>
         <source>Ctrl+O</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="430"/>
-        <location filename="../ui/mainwindow.ui" line="443"/>
-        <source>&amp;Preferences...</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="433"/>
-        <location filename="../ui/mainwindow.ui" line="446"/>
-        <source>Preferences...</source>
         <translation type="unfinished"></translation>
     </message>
@@ -312,41 +293,41 @@
         <location filename="../ui/mainwindow.ce.ui" line="436"/>
         <location filename="../ui/mainwindow.ui" line="449"/>
+        <source>&amp;Preferences...</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="439"/>
+        <location filename="../ui/mainwindow.ui" line="452"/>
+        <source>Preferences...</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="442"/>
+        <location filename="../ui/mainwindow.ui" line="455"/>
         <source>Application preferences</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="448"/>
-        <location filename="../ui/mainwindow.ui" line="461"/>
+        <location filename="../ui/mainwindow.ce.ui" line="454"/>
+        <location filename="../ui/mainwindow.ui" line="467"/>
         <source>&amp;Contents</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="451"/>
-        <location filename="../ui/mainwindow.ui" line="464"/>
+        <location filename="../ui/mainwindow.ce.ui" line="457"/>
+        <location filename="../ui/mainwindow.ui" line="470"/>
         <source>Open help contents</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="463"/>
-        <location filename="../ui/mainwindow.ui" line="476"/>
+        <location filename="../ui/mainwindow.ce.ui" line="469"/>
+        <location filename="../ui/mainwindow.ui" line="482"/>
         <source>&amp;Context help</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="466"/>
-        <location filename="../ui/mainwindow.ui" line="479"/>
+        <location filename="../ui/mainwindow.ce.ui" line="472"/>
+        <location filename="../ui/mainwindow.ui" line="485"/>
         <source>Open context help</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="475"/>
-        <location filename="../ui/mainwindow.ui" line="488"/>
-        <source>&amp;About...</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="478"/>
-        <location filename="../ui/mainwindow.ui" line="491"/>
-        <source>About...</source>
         <translation type="unfinished"></translation>
     </message>
@@ -354,29 +335,29 @@
         <location filename="../ui/mainwindow.ce.ui" line="481"/>
         <location filename="../ui/mainwindow.ui" line="494"/>
+        <source>&amp;About...</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="484"/>
+        <location filename="../ui/mainwindow.ui" line="497"/>
+        <source>About...</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="487"/>
+        <location filename="../ui/mainwindow.ui" line="500"/>
         <source>About application</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="490"/>
-        <location filename="../ui/mainwindow.ui" line="503"/>
+        <location filename="../ui/mainwindow.ce.ui" line="496"/>
+        <location filename="../ui/mainwindow.ui" line="509"/>
         <source>E&amp;xit</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="493"/>
-        <location filename="../ui/mainwindow.ui" line="506"/>
+        <location filename="../ui/mainwindow.ce.ui" line="499"/>
+        <location filename="../ui/mainwindow.ui" line="512"/>
         <source>Exit application</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="505"/>
-        <location filename="../ui/mainwindow.ui" line="518"/>
-        <source>&amp;Task...</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="508"/>
-        <location filename="../ui/mainwindow.ui" line="521"/>
-        <source>Task...</source>
         <translation type="unfinished"></translation>
     </message>
@@ -384,5 +365,5 @@
         <location filename="../ui/mainwindow.ce.ui" line="511"/>
         <location filename="../ui/mainwindow.ui" line="524"/>
-        <source>Save task</source>
+        <source>&amp;Task...</source>
         <translation type="unfinished"></translation>
     </message>
@@ -390,5 +371,5 @@
         <location filename="../ui/mainwindow.ce.ui" line="514"/>
         <location filename="../ui/mainwindow.ui" line="527"/>
-        <source>Save task to file</source>
+        <source>Task...</source>
         <translation type="unfinished"></translation>
     </message>
@@ -396,11 +377,28 @@
         <location filename="../ui/mainwindow.ce.ui" line="517"/>
         <location filename="../ui/mainwindow.ui" line="530"/>
+        <source>Save task</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="520"/>
+        <location filename="../ui/mainwindow.ui" line="533"/>
+        <source>Save task to file</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="523"/>
+        <location filename="../ui/mainwindow.ui" line="536"/>
         <source>Ctrl+S</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="528"/>
-        <location filename="../ui/mainwindow.ui" line="541"/>
+        <location filename="../ui/mainwindow.ce.ui" line="534"/>
+        <location filename="../ui/mainwindow.ui" line="547"/>
         <source>&amp;Autodetect</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="551"/>
+        <source>English</source>
         <translation type="unfinished"></translation>
     </message>
@@ -418,37 +416,37 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="326"/>
+        <location filename="../ui/mainwindow.ui" line="332"/>
         <source>P&amp;rint setup...</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="329"/>
+        <location filename="../ui/mainwindow.ui" line="335"/>
         <source>Setup printing</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="341"/>
+        <location filename="../ui/mainwindow.ui" line="347"/>
         <source>&amp;Print...</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="344"/>
+        <location filename="../ui/mainwindow.ui" line="350"/>
         <source>Print solution results</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="347"/>
+        <location filename="../ui/mainwindow.ui" line="353"/>
         <source>Ctrl+P</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="531"/>
-        <location filename="../ui/mainwindow.ui" line="544"/>
+        <location filename="../ui/mainwindow.ce.ui" line="537"/>
+        <location filename="../ui/mainwindow.ui" line="550"/>
         <source>Detect language automatically</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="534"/>
-        <location filename="../ui/mainwindow.ui" line="547"/>
+        <location filename="../ui/mainwindow.ce.ui" line="540"/>
+        <location filename="../ui/mainwindow.ui" line="553"/>
         <source>Detect language automatically based on regional settings</source>
         <translation type="unfinished"></translation>
Index: trunk/i18n/languages.ini
===================================================================
--- trunk/i18n/languages.ini	(revision 30)
+++ trunk/i18n/languages.ini	(revision 30)
@@ -0,0 +1,10 @@
+﻿
+[en]
+Name=English
+NativeName=English
+[ru]
+Name=Russian
+NativeName=Русский
+[uk]
+Name=Ukrainian
+NativeName=Українська
Index: trunk/i18n/ru.ts
===================================================================
--- trunk/i18n/ru.ts	(revision 29)
+++ trunk/i18n/ru.ts	(revision 30)
@@ -4,18 +4,57 @@
 <defaultcodec>UTF-8</defaultcodec>
 <context>
-    <name></name>
-    <message>
-        <location filename="../src/mainwindow.cpp" line="244"/>
-        <location filename="../src/mainwindow.cpp" line="253"/>
+    <name>CTSPModel</name>
+    <message>
+        <location filename="../src/tspmodel.cpp" line="52"/>
+        <source>City %1</source>
+        <translation>Город %1</translation>
+    </message>
+    <message>
+        <location filename="../src/tspmodel.cpp" line="54"/>
+        <source>%1</source>
+        <translation></translation>
+    </message>
+</context>
+<context>
+    <name>MainWindow</name>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="125"/>
+        <location filename="../src/mainwindow.cpp" line="246"/>
+        <location filename="../src/mainwindow.cpp" line="255"/>
         <source>Language change</source>
         <translation>Смена языка</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="244"/>
+        <location filename="../src/mainwindow.cpp" line="125"/>
+        <source>Unable to load translation language.</source>
+        <translation>Невозможно загрузить перевод.</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="192"/>
+        <source>Data error</source>
+        <translation>Ошибка в данных</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="192"/>
+        <source>Error in cell [Row %1; Column %2]: Invalid data format.</source>
+        <translation>Ошибка в ячейке [Строка %1; Колонка %2]: Неверный формат данных.</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="201"/>
+        <source>Solution error</source>
+        <translation>Ошибка при решении</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="201"/>
+        <source>There was an error while solving the task.</source>
+        <translation>Во время решения задачи возникла ошибка.</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="246"/>
         <source>Language will be autodetected on next application start.</source>
         <translation>Язык будет автоматически определен при следующем запуске приложения.</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="253"/>
+        <location filename="../src/mainwindow.cpp" line="255"/>
         <source>You have language autodetection turned on.
 It needs to be off.
@@ -25,50 +64,4 @@
 Отключить его?</translation>
     </message>
-</context>
-<context>
-    <name>CTSPModel</name>
-    <message>
-        <location filename="../src/tspmodel.cpp" line="52"/>
-        <source>City %1</source>
-        <translation>Город %1</translation>
-    </message>
-    <message>
-        <location filename="../src/tspmodel.cpp" line="54"/>
-        <source>%1</source>
-        <translation></translation>
-    </message>
-</context>
-<context>
-    <name>MainWindow</name>
-    <message>
-        <location filename="../src/mainwindow.cpp" line="122"/>
-        <source>Language change</source>
-        <translation>Смена языка</translation>
-    </message>
-    <message>
-        <location filename="../src/mainwindow.cpp" line="122"/>
-        <source>Unable to load translation language.</source>
-        <translation>Невозможно загрузить перевод.</translation>
-    </message>
-    <message>
-        <location filename="../src/mainwindow.cpp" line="189"/>
-        <source>Data error</source>
-        <translation>Ошибка в данных</translation>
-    </message>
-    <message>
-        <location filename="../src/mainwindow.cpp" line="189"/>
-        <source>Error in cell [Row %1; Column %2]: Invalid data format.</source>
-        <translation>Ошибка в ячейке [Строка %1; Колонка %2]: Неверный формат данных.</translation>
-    </message>
-    <message>
-        <location filename="../src/mainwindow.cpp" line="198"/>
-        <source>Solution error</source>
-        <translation>Ошибка при решении</translation>
-    </message>
-    <message>
-        <location filename="../src/mainwindow.cpp" line="198"/>
-        <source>There was an error while solving the task.</source>
-        <translation>Во время решения задачи возникла ошибка.</translation>
-    </message>
     <message>
         <location filename="../ui/mainwindow.ce.ui" line="17"/>
@@ -180,230 +173,235 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="302"/>
-        <location filename="../ui/mainwindow.ui" line="283"/>
+        <location filename="../ui/mainwindow.ce.ui" line="308"/>
+        <location filename="../ui/mainwindow.ui" line="289"/>
         <source>&amp;Help</source>
         <translation>&amp;Помощь</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="342"/>
-        <location filename="../ui/mainwindow.ui" line="355"/>
+        <location filename="../ui/mainwindow.ce.ui" line="348"/>
+        <location filename="../ui/mainwindow.ui" line="361"/>
         <source>Solution st&amp;eps</source>
         <translation>&amp;Ход решения</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="345"/>
-        <location filename="../ui/mainwindow.ui" line="358"/>
+        <location filename="../ui/mainwindow.ce.ui" line="351"/>
+        <location filename="../ui/mainwindow.ui" line="364"/>
         <source>Save solution steps</source>
         <translation>Сохранить ход решения</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="348"/>
-        <location filename="../ui/mainwindow.ui" line="361"/>
+        <location filename="../ui/mainwindow.ce.ui" line="354"/>
+        <location filename="../ui/mainwindow.ui" line="367"/>
         <source>Save solution steps only</source>
         <translation>Сохранить только ход решения</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="356"/>
-        <location filename="../ui/mainwindow.ui" line="369"/>
+        <location filename="../ui/mainwindow.ce.ui" line="362"/>
+        <location filename="../ui/mainwindow.ui" line="375"/>
         <source>Solution &amp;graph</source>
         <translation>&amp;Граф решения</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="359"/>
-        <location filename="../ui/mainwindow.ui" line="372"/>
+        <location filename="../ui/mainwindow.ce.ui" line="365"/>
+        <location filename="../ui/mainwindow.ui" line="378"/>
         <source>Save solution graph</source>
         <translation>Сохранить граф решения</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="362"/>
-        <location filename="../ui/mainwindow.ui" line="375"/>
+        <location filename="../ui/mainwindow.ce.ui" line="368"/>
+        <location filename="../ui/mainwindow.ui" line="381"/>
         <source>Save solution graph only</source>
         <translation>Сохранить только граф решения</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="370"/>
-        <location filename="../ui/mainwindow.ui" line="383"/>
+        <location filename="../ui/mainwindow.ce.ui" line="376"/>
+        <location filename="../ui/mainwindow.ui" line="389"/>
         <source>&amp;Solution</source>
         <translation>&amp;Решение</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="373"/>
-        <location filename="../ui/mainwindow.ui" line="386"/>
+        <location filename="../ui/mainwindow.ce.ui" line="379"/>
+        <location filename="../ui/mainwindow.ui" line="392"/>
         <source>Save solution</source>
         <translation>Сохранить решение</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="376"/>
-        <location filename="../ui/mainwindow.ui" line="389"/>
+        <location filename="../ui/mainwindow.ce.ui" line="382"/>
+        <location filename="../ui/mainwindow.ui" line="395"/>
         <source>Save solution steps and graph</source>
         <translation>Сохранить ход и граф решения</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="385"/>
-        <location filename="../ui/mainwindow.ui" line="398"/>
+        <location filename="../ui/mainwindow.ce.ui" line="391"/>
+        <location filename="../ui/mainwindow.ui" line="404"/>
         <source>&amp;New</source>
         <translation>&amp;Создать</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="388"/>
-        <location filename="../ui/mainwindow.ui" line="401"/>
+        <location filename="../ui/mainwindow.ce.ui" line="394"/>
+        <location filename="../ui/mainwindow.ui" line="407"/>
         <source>New</source>
         <translation>Создать</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="391"/>
-        <location filename="../ui/mainwindow.ui" line="404"/>
+        <location filename="../ui/mainwindow.ce.ui" line="397"/>
+        <location filename="../ui/mainwindow.ui" line="410"/>
         <source>New task</source>
         <translation>Создать задачу</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="394"/>
-        <location filename="../ui/mainwindow.ui" line="407"/>
+        <location filename="../ui/mainwindow.ce.ui" line="400"/>
+        <location filename="../ui/mainwindow.ui" line="413"/>
         <source>Create new task</source>
         <translation>Создать новую задачу</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="397"/>
-        <location filename="../ui/mainwindow.ui" line="410"/>
+        <location filename="../ui/mainwindow.ce.ui" line="403"/>
+        <location filename="../ui/mainwindow.ui" line="416"/>
         <source>Ctrl+N</source>
         <translation></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="409"/>
-        <location filename="../ui/mainwindow.ui" line="422"/>
+        <location filename="../ui/mainwindow.ce.ui" line="415"/>
+        <location filename="../ui/mainwindow.ui" line="428"/>
         <source>&amp;Open...</source>
         <translation>&amp;Открыть...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="412"/>
-        <location filename="../ui/mainwindow.ui" line="425"/>
+        <location filename="../ui/mainwindow.ce.ui" line="418"/>
+        <location filename="../ui/mainwindow.ui" line="431"/>
         <source>Open...</source>
         <translation>Открыть...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="415"/>
-        <location filename="../ui/mainwindow.ui" line="428"/>
+        <location filename="../ui/mainwindow.ce.ui" line="421"/>
+        <location filename="../ui/mainwindow.ui" line="434"/>
         <source>Open task</source>
         <translation>Открыть задачу</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="418"/>
-        <location filename="../ui/mainwindow.ui" line="431"/>
+        <location filename="../ui/mainwindow.ce.ui" line="424"/>
+        <location filename="../ui/mainwindow.ui" line="437"/>
         <source>Open saved task</source>
         <translation>Открыть сохраненное условие задачи</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="421"/>
-        <location filename="../ui/mainwindow.ui" line="434"/>
+        <location filename="../ui/mainwindow.ce.ui" line="427"/>
+        <location filename="../ui/mainwindow.ui" line="440"/>
         <source>Ctrl+O</source>
         <translation></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="430"/>
-        <location filename="../ui/mainwindow.ui" line="443"/>
+        <location filename="../ui/mainwindow.ce.ui" line="436"/>
+        <location filename="../ui/mainwindow.ui" line="449"/>
         <source>&amp;Preferences...</source>
         <translation>&amp;Параметры...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="433"/>
-        <location filename="../ui/mainwindow.ui" line="446"/>
+        <location filename="../ui/mainwindow.ce.ui" line="439"/>
+        <location filename="../ui/mainwindow.ui" line="452"/>
         <source>Preferences...</source>
         <translation>Параметры...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="436"/>
-        <location filename="../ui/mainwindow.ui" line="449"/>
+        <location filename="../ui/mainwindow.ce.ui" line="442"/>
+        <location filename="../ui/mainwindow.ui" line="455"/>
         <source>Application preferences</source>
         <translation>Настройка параметров программмы</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="448"/>
-        <location filename="../ui/mainwindow.ui" line="461"/>
+        <location filename="../ui/mainwindow.ce.ui" line="454"/>
+        <location filename="../ui/mainwindow.ui" line="467"/>
         <source>&amp;Contents</source>
         <translation>&amp;Содежание</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="451"/>
-        <location filename="../ui/mainwindow.ui" line="464"/>
+        <location filename="../ui/mainwindow.ce.ui" line="457"/>
+        <location filename="../ui/mainwindow.ui" line="470"/>
         <source>Open help contents</source>
         <translation>Вызвать справку программы</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="463"/>
-        <location filename="../ui/mainwindow.ui" line="476"/>
+        <location filename="../ui/mainwindow.ce.ui" line="469"/>
+        <location filename="../ui/mainwindow.ui" line="482"/>
         <source>&amp;Context help</source>
         <translation>&amp;Контекстная справка</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="466"/>
-        <location filename="../ui/mainwindow.ui" line="479"/>
+        <location filename="../ui/mainwindow.ce.ui" line="472"/>
+        <location filename="../ui/mainwindow.ui" line="485"/>
         <source>Open context help</source>
         <translation>Вызвать контекстную справку</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="475"/>
-        <location filename="../ui/mainwindow.ui" line="488"/>
+        <location filename="../ui/mainwindow.ce.ui" line="481"/>
+        <location filename="../ui/mainwindow.ui" line="494"/>
         <source>&amp;About...</source>
         <translation>&amp;Про...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="478"/>
-        <location filename="../ui/mainwindow.ui" line="491"/>
+        <location filename="../ui/mainwindow.ce.ui" line="484"/>
+        <location filename="../ui/mainwindow.ui" line="497"/>
         <source>About...</source>
         <translation>Про...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="481"/>
-        <location filename="../ui/mainwindow.ui" line="494"/>
+        <location filename="../ui/mainwindow.ce.ui" line="487"/>
+        <location filename="../ui/mainwindow.ui" line="500"/>
         <source>About application</source>
         <translation>О программе</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="490"/>
-        <location filename="../ui/mainwindow.ui" line="503"/>
+        <location filename="../ui/mainwindow.ce.ui" line="496"/>
+        <location filename="../ui/mainwindow.ui" line="509"/>
         <source>E&amp;xit</source>
         <translation>В&amp;ыход</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="493"/>
-        <location filename="../ui/mainwindow.ui" line="506"/>
+        <location filename="../ui/mainwindow.ce.ui" line="499"/>
+        <location filename="../ui/mainwindow.ui" line="512"/>
         <source>Exit application</source>
         <translation>Выйти из приложения</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="505"/>
-        <location filename="../ui/mainwindow.ui" line="518"/>
+        <location filename="../ui/mainwindow.ce.ui" line="511"/>
+        <location filename="../ui/mainwindow.ui" line="524"/>
         <source>&amp;Task...</source>
         <translation>&amp;Задачу...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="508"/>
-        <location filename="../ui/mainwindow.ui" line="521"/>
+        <location filename="../ui/mainwindow.ce.ui" line="514"/>
+        <location filename="../ui/mainwindow.ui" line="527"/>
         <source>Task...</source>
         <translation>Задачу...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="511"/>
-        <location filename="../ui/mainwindow.ui" line="524"/>
+        <location filename="../ui/mainwindow.ce.ui" line="517"/>
+        <location filename="../ui/mainwindow.ui" line="530"/>
         <source>Save task</source>
         <translation>Сохранить задачу</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="514"/>
-        <location filename="../ui/mainwindow.ui" line="527"/>
+        <location filename="../ui/mainwindow.ce.ui" line="520"/>
+        <location filename="../ui/mainwindow.ui" line="533"/>
         <source>Save task to file</source>
         <translation>Сохранить условие задачи в файл</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="517"/>
-        <location filename="../ui/mainwindow.ui" line="530"/>
+        <location filename="../ui/mainwindow.ce.ui" line="523"/>
+        <location filename="../ui/mainwindow.ui" line="536"/>
         <source>Ctrl+S</source>
         <translation></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="528"/>
-        <location filename="../ui/mainwindow.ui" line="541"/>
+        <location filename="../ui/mainwindow.ce.ui" line="534"/>
+        <location filename="../ui/mainwindow.ui" line="547"/>
         <source>&amp;Autodetect</source>
         <translation>&amp;Автоопределение</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="551"/>
+        <source>English</source>
+        <translation>Английский</translation>
     </message>
     <message>
@@ -420,37 +418,37 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="326"/>
+        <location filename="../ui/mainwindow.ui" line="332"/>
         <source>P&amp;rint setup...</source>
         <translation>&amp;Настройка печати...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="329"/>
+        <location filename="../ui/mainwindow.ui" line="335"/>
         <source>Setup printing</source>
         <translation>Настроить печать</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="341"/>
+        <location filename="../ui/mainwindow.ui" line="347"/>
         <source>&amp;Print...</source>
         <translation>&amp;Печать...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="344"/>
+        <location filename="../ui/mainwindow.ui" line="350"/>
         <source>Print solution results</source>
         <translation>Распечатать результаты решения</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="347"/>
+        <location filename="../ui/mainwindow.ui" line="353"/>
         <source>Ctrl+P</source>
         <translation></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="531"/>
-        <location filename="../ui/mainwindow.ui" line="544"/>
+        <location filename="../ui/mainwindow.ce.ui" line="537"/>
+        <location filename="../ui/mainwindow.ui" line="550"/>
         <source>Detect language automatically</source>
         <translation>Определять язык автоматически</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="534"/>
-        <location filename="../ui/mainwindow.ui" line="547"/>
+        <location filename="../ui/mainwindow.ce.ui" line="540"/>
+        <location filename="../ui/mainwindow.ui" line="553"/>
         <source>Detect language automatically based on regional settings</source>
         <translation>Определять язык автоматически, основываясь на региональных настройках</translation>
Index: trunk/i18n/uk.ts
===================================================================
--- trunk/i18n/uk.ts	(revision 29)
+++ trunk/i18n/uk.ts	(revision 30)
@@ -4,18 +4,447 @@
 <defaultcodec>UTF-8</defaultcodec>
 <context>
-    <name></name>
-    <message>
-        <location filename="../src/mainwindow.cpp" line="244"/>
-        <location filename="../src/mainwindow.cpp" line="253"/>
+    <name>CTSPModel</name>
+    <message>
+        <location filename="../src/tspmodel.cpp" line="52"/>
+        <source>City %1</source>
+        <translation>Місто %1</translation>
+    </message>
+    <message>
+        <location filename="../src/tspmodel.cpp" line="54"/>
+        <source>%1</source>
+        <translation></translation>
+    </message>
+</context>
+<context>
+    <name>MainWindow</name>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="90"/>
+        <location filename="../ui/mainwindow.ui" line="69"/>
+        <source>Number of variant</source>
+        <translation>Номер варіанту</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="113"/>
+        <location filename="../ui/mainwindow.ui" line="92"/>
+        <source>Number of cities</source>
+        <translation>Кількість міст, що проходить комівояжер</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="286"/>
+        <location filename="../ui/mainwindow.ui" line="267"/>
+        <source>Select language</source>
+        <translation>Вибір мови</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="289"/>
+        <location filename="../ui/mainwindow.ui" line="270"/>
+        <source>Select application language</source>
+        <translation>Обрати мову додатку</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ui" line="332"/>
+        <source>P&amp;rint setup...</source>
+        <translation>&amp;Налагодження друку...</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ui" line="335"/>
+        <source>Setup printing</source>
+        <translation>Налагодити друк</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ui" line="347"/>
+        <source>&amp;Print...</source>
+        <translation>&amp;Друк...</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ui" line="350"/>
+        <source>Print solution results</source>
+        <translation>Роздрукувати результат розв&apos;язку</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ui" line="353"/>
+        <source>Ctrl+P</source>
+        <translation></translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="537"/>
+        <location filename="../ui/mainwindow.ui" line="550"/>
+        <source>Detect language automatically</source>
+        <translation>Визначати мову автоматично</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="540"/>
+        <location filename="../ui/mainwindow.ui" line="553"/>
+        <source>Detect language automatically based on regional settings</source>
+        <translation type="unfinished">Визначати мову автоматично, використовуючи регіональні стандарти</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="523"/>
+        <location filename="../ui/mainwindow.ui" line="536"/>
+        <source>Ctrl+S</source>
+        <translation></translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="403"/>
+        <location filename="../ui/mainwindow.ui" line="416"/>
+        <source>Ctrl+N</source>
+        <translation></translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="17"/>
+        <location filename="../ui/mainwindow.ui" line="14"/>
+        <source>Travelling salesman problem</source>
+        <translation>Задача комівояжера</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="56"/>
+        <location filename="../ui/mainwindow.ui" line="35"/>
+        <source>Task</source>
+        <translation>Завдання</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="77"/>
+        <location filename="../ui/mainwindow.ui" line="56"/>
+        <source>&amp;Variant:</source>
+        <translation>&amp;Варіант:</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="100"/>
+        <location filename="../ui/mainwindow.ui" line="79"/>
+        <source>&amp;Cities:</source>
+        <translation>&amp;Міст:</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="144"/>
+        <location filename="../ui/mainwindow.ui" line="123"/>
+        <source>Cost of travel from city to city</source>
+        <translation>Вартість переїзду з міста у місто</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="172"/>
+        <location filename="../ui/mainwindow.ui" line="151"/>
+        <source>Fill table with random numbers</source>
+        <translation>Заповнити таблицю випадковими значеннями</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="175"/>
+        <location filename="../ui/mainwindow.ui" line="154"/>
+        <source>Random</source>
+        <translation>Випадково</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="185"/>
+        <location filename="../ui/mainwindow.ui" line="164"/>
+        <source>Solve current task</source>
+        <translation>Розв&apos;язати поточну задачу</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="188"/>
+        <location filename="../ui/mainwindow.ui" line="167"/>
+        <source>Solve</source>
+        <translation>Розв&apos;язати</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="202"/>
+        <location filename="../ui/mainwindow.ui" line="181"/>
+        <source>Solution</source>
+        <translation>Розв&apos;язок</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="219"/>
+        <location filename="../ui/mainwindow.ui" line="198"/>
+        <source>Solution steps</source>
+        <translation>Хід розв&apos;язку</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="229"/>
+        <location filename="../ui/mainwindow.ui" line="208"/>
+        <source>Solution graph</source>
+        <translation>Граф розв&apos;язку</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="255"/>
+        <location filename="../ui/mainwindow.ui" line="236"/>
+        <source>&amp;File</source>
+        <translation>&amp;Файл</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="262"/>
+        <location filename="../ui/mainwindow.ui" line="240"/>
+        <source>&amp;Save</source>
+        <translation>&amp;Зберегти</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="282"/>
+        <location filename="../ui/mainwindow.ui" line="263"/>
+        <source>&amp;Settings</source>
+        <translation>&amp;Налагодження</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="292"/>
+        <location filename="../ui/mainwindow.ui" line="273"/>
+        <source>&amp;Language</source>
+        <translation>Мова / &amp;Language</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="308"/>
+        <location filename="../ui/mainwindow.ui" line="289"/>
+        <source>&amp;Help</source>
+        <translation>&amp;Допомога</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="348"/>
+        <location filename="../ui/mainwindow.ui" line="361"/>
+        <source>Solution st&amp;eps</source>
+        <translation>&amp;Хід розв&apos;язку</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="351"/>
+        <location filename="../ui/mainwindow.ui" line="364"/>
+        <source>Save solution steps</source>
+        <translation>Зберегти хід розв&apos;язку</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="354"/>
+        <location filename="../ui/mainwindow.ui" line="367"/>
+        <source>Save solution steps only</source>
+        <translation>Зберегти тільки хід розв&apos;язку</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="362"/>
+        <location filename="../ui/mainwindow.ui" line="375"/>
+        <source>Solution &amp;graph</source>
+        <translation>&amp;Граф розв&apos;язку</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="365"/>
+        <location filename="../ui/mainwindow.ui" line="378"/>
+        <source>Save solution graph</source>
+        <translation>Зберегти граф розв&apos;язку</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="368"/>
+        <location filename="../ui/mainwindow.ui" line="381"/>
+        <source>Save solution graph only</source>
+        <translation>Зберегти тільки граф розв&apos;язку</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="376"/>
+        <location filename="../ui/mainwindow.ui" line="389"/>
+        <source>&amp;Solution</source>
+        <translation>&amp;Розв&apos;язок</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="379"/>
+        <location filename="../ui/mainwindow.ui" line="392"/>
+        <source>Save solution</source>
+        <translation>Зберегти розв&apos;язок</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="382"/>
+        <location filename="../ui/mainwindow.ui" line="395"/>
+        <source>Save solution steps and graph</source>
+        <translation>Зберегти хід та граф розв&apos;язку</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="391"/>
+        <location filename="../ui/mainwindow.ui" line="404"/>
+        <source>&amp;New</source>
+        <translation>&amp;Створити</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="394"/>
+        <location filename="../ui/mainwindow.ui" line="407"/>
+        <source>New</source>
+        <translation>Створити</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="397"/>
+        <location filename="../ui/mainwindow.ui" line="410"/>
+        <source>New task</source>
+        <translation>Нове завдання</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="400"/>
+        <location filename="../ui/mainwindow.ui" line="413"/>
+        <source>Create new task</source>
+        <translation>Створити нове завдання</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="415"/>
+        <location filename="../ui/mainwindow.ui" line="428"/>
+        <source>&amp;Open...</source>
+        <translation>&amp;Відкрити...</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="418"/>
+        <location filename="../ui/mainwindow.ui" line="431"/>
+        <source>Open...</source>
+        <translation>Відкрити...</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="421"/>
+        <location filename="../ui/mainwindow.ui" line="434"/>
+        <source>Open task</source>
+        <translation>Відкрити завдання</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="424"/>
+        <location filename="../ui/mainwindow.ui" line="437"/>
+        <source>Open saved task</source>
+        <translation>Відкрити збережене завдання</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="427"/>
+        <location filename="../ui/mainwindow.ui" line="440"/>
+        <source>Ctrl+O</source>
+        <translation></translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="436"/>
+        <location filename="../ui/mainwindow.ui" line="449"/>
+        <source>&amp;Preferences...</source>
+        <translation>&amp;Параметри...</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="439"/>
+        <location filename="../ui/mainwindow.ui" line="452"/>
+        <source>Preferences...</source>
+        <translation>Параметри...</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="442"/>
+        <location filename="../ui/mainwindow.ui" line="455"/>
+        <source>Application preferences</source>
+        <translation>Параметри додатку</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="454"/>
+        <location filename="../ui/mainwindow.ui" line="467"/>
+        <source>&amp;Contents</source>
+        <translation>&amp;Зміст</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="457"/>
+        <location filename="../ui/mainwindow.ui" line="470"/>
+        <source>Open help contents</source>
+        <translation>Відкрити зміст допомоги</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="469"/>
+        <location filename="../ui/mainwindow.ui" line="482"/>
+        <source>&amp;Context help</source>
+        <translation>&amp;Контекстна допомога</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="472"/>
+        <location filename="../ui/mainwindow.ui" line="485"/>
+        <source>Open context help</source>
+        <translation>Відкрити контекстну допомогу</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="481"/>
+        <location filename="../ui/mainwindow.ui" line="494"/>
+        <source>&amp;About...</source>
+        <translation>&amp;Про...</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="484"/>
+        <location filename="../ui/mainwindow.ui" line="497"/>
+        <source>About...</source>
+        <translation>Про...</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="487"/>
+        <location filename="../ui/mainwindow.ui" line="500"/>
+        <source>About application</source>
+        <translation>Про додаток</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="496"/>
+        <location filename="../ui/mainwindow.ui" line="509"/>
+        <source>E&amp;xit</source>
+        <translation>В&amp;ихід</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="499"/>
+        <location filename="../ui/mainwindow.ui" line="512"/>
+        <source>Exit application</source>
+        <translation>Вийти з додатку</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="511"/>
+        <location filename="../ui/mainwindow.ui" line="524"/>
+        <source>&amp;Task...</source>
+        <translation>&amp;Завдання...</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="514"/>
+        <location filename="../ui/mainwindow.ui" line="527"/>
+        <source>Task...</source>
+        <translation>Завдання...</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="517"/>
+        <location filename="../ui/mainwindow.ui" line="530"/>
+        <source>Save task</source>
+        <translation>Зберегти завдання</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="520"/>
+        <location filename="../ui/mainwindow.ui" line="533"/>
+        <source>Save task to file</source>
+        <translation>Зберегти завдання до файлу</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="534"/>
+        <location filename="../ui/mainwindow.ui" line="547"/>
+        <source>&amp;Autodetect</source>
+        <translation>&amp;Автовизначення</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="551"/>
+        <source>English</source>
+        <translation>Англійська</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="125"/>
+        <location filename="../src/mainwindow.cpp" line="246"/>
+        <location filename="../src/mainwindow.cpp" line="255"/>
         <source>Language change</source>
         <translation>Зміна мови</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="244"/>
+        <location filename="../src/mainwindow.cpp" line="125"/>
+        <source>Unable to load translation language.</source>
+        <translation>Неможливо завантажити переклад.</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="192"/>
+        <source>Data error</source>
+        <translation>Помилка даних</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="192"/>
+        <source>Error in cell [Row %1; Column %2]: Invalid data format.</source>
+        <translation>Помилка у комірці  [Рядок %1; Колонка %2]: Невірний формат даних.</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="201"/>
+        <source>Solution error</source>
+        <translation>Помилка розв&apos;язку</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="201"/>
+        <source>There was an error while solving the task.</source>
+        <translation>Під час розв&apos;язання задачі виникла помилка.</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="246"/>
         <source>Language will be autodetected on next application start.</source>
         <translation>Мову буде автоматично визначено при наступному запуску додатку.</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="253"/>
+        <location filename="../src/mainwindow.cpp" line="255"/>
         <source>You have language autodetection turned on.
 It needs to be off.
@@ -27,435 +456,4 @@
 </context>
 <context>
-    <name>CTSPModel</name>
-    <message>
-        <location filename="../src/tspmodel.cpp" line="52"/>
-        <source>City %1</source>
-        <translation>Місто %1</translation>
-    </message>
-    <message>
-        <location filename="../src/tspmodel.cpp" line="54"/>
-        <source>%1</source>
-        <translation></translation>
-    </message>
-</context>
-<context>
-    <name>MainWindow</name>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="90"/>
-        <location filename="../ui/mainwindow.ui" line="69"/>
-        <source>Number of variant</source>
-        <translation>Номер варіанту</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="113"/>
-        <location filename="../ui/mainwindow.ui" line="92"/>
-        <source>Number of cities</source>
-        <translation>Кількість міст, що проходить комівояжер</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="286"/>
-        <location filename="../ui/mainwindow.ui" line="267"/>
-        <source>Select language</source>
-        <translation>Вибір мови</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="289"/>
-        <location filename="../ui/mainwindow.ui" line="270"/>
-        <source>Select application language</source>
-        <translation>Обрати мову додатку</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ui" line="326"/>
-        <source>P&amp;rint setup...</source>
-        <translation>&amp;Налагодження друку...</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ui" line="329"/>
-        <source>Setup printing</source>
-        <translation>Налагодити друк</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ui" line="341"/>
-        <source>&amp;Print...</source>
-        <translation>&amp;Друк...</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ui" line="344"/>
-        <source>Print solution results</source>
-        <translation>Роздрукувати результат розв&apos;язку</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ui" line="347"/>
-        <source>Ctrl+P</source>
-        <translation></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="531"/>
-        <location filename="../ui/mainwindow.ui" line="544"/>
-        <source>Detect language automatically</source>
-        <translation>Визначати мову автоматично</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="534"/>
-        <location filename="../ui/mainwindow.ui" line="547"/>
-        <source>Detect language automatically based on regional settings</source>
-        <translation type="unfinished">Визначати мову автоматично, використовуючи регіональні стандарти</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="517"/>
-        <location filename="../ui/mainwindow.ui" line="530"/>
-        <source>Ctrl+S</source>
-        <translation></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="397"/>
-        <location filename="../ui/mainwindow.ui" line="410"/>
-        <source>Ctrl+N</source>
-        <translation></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="17"/>
-        <location filename="../ui/mainwindow.ui" line="14"/>
-        <source>Travelling salesman problem</source>
-        <translation>Задача комівояжера</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="56"/>
-        <location filename="../ui/mainwindow.ui" line="35"/>
-        <source>Task</source>
-        <translation>Завдання</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="77"/>
-        <location filename="../ui/mainwindow.ui" line="56"/>
-        <source>&amp;Variant:</source>
-        <translation>&amp;Варіант:</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="100"/>
-        <location filename="../ui/mainwindow.ui" line="79"/>
-        <source>&amp;Cities:</source>
-        <translation>&amp;Міст:</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="144"/>
-        <location filename="../ui/mainwindow.ui" line="123"/>
-        <source>Cost of travel from city to city</source>
-        <translation>Вартість переїзду з міста у місто</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="172"/>
-        <location filename="../ui/mainwindow.ui" line="151"/>
-        <source>Fill table with random numbers</source>
-        <translation>Заповнити таблицю випадковими значеннями</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="175"/>
-        <location filename="../ui/mainwindow.ui" line="154"/>
-        <source>Random</source>
-        <translation>Випадково</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="185"/>
-        <location filename="../ui/mainwindow.ui" line="164"/>
-        <source>Solve current task</source>
-        <translation>Розв&apos;язати поточну задачу</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="188"/>
-        <location filename="../ui/mainwindow.ui" line="167"/>
-        <source>Solve</source>
-        <translation>Розв&apos;язати</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="202"/>
-        <location filename="../ui/mainwindow.ui" line="181"/>
-        <source>Solution</source>
-        <translation>Розв&apos;язок</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="219"/>
-        <location filename="../ui/mainwindow.ui" line="198"/>
-        <source>Solution steps</source>
-        <translation>Хід розв&apos;язку</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="229"/>
-        <location filename="../ui/mainwindow.ui" line="208"/>
-        <source>Solution graph</source>
-        <translation>Граф розв&apos;язку</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="255"/>
-        <location filename="../ui/mainwindow.ui" line="236"/>
-        <source>&amp;File</source>
-        <translation>&amp;Файл</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="262"/>
-        <location filename="../ui/mainwindow.ui" line="240"/>
-        <source>&amp;Save</source>
-        <translation>&amp;Зберегти</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="282"/>
-        <location filename="../ui/mainwindow.ui" line="263"/>
-        <source>&amp;Settings</source>
-        <translation>&amp;Налагодження</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="292"/>
-        <location filename="../ui/mainwindow.ui" line="273"/>
-        <source>&amp;Language</source>
-        <translation>Мова / &amp;Language</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="302"/>
-        <location filename="../ui/mainwindow.ui" line="283"/>
-        <source>&amp;Help</source>
-        <translation>&amp;Допомога</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="342"/>
-        <location filename="../ui/mainwindow.ui" line="355"/>
-        <source>Solution st&amp;eps</source>
-        <translation>&amp;Хід розв&apos;язку</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="345"/>
-        <location filename="../ui/mainwindow.ui" line="358"/>
-        <source>Save solution steps</source>
-        <translation>Зберегти хід розв&apos;язку</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="348"/>
-        <location filename="../ui/mainwindow.ui" line="361"/>
-        <source>Save solution steps only</source>
-        <translation>Зберегти тільки хід розв&apos;язку</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="356"/>
-        <location filename="../ui/mainwindow.ui" line="369"/>
-        <source>Solution &amp;graph</source>
-        <translation>&amp;Граф розв&apos;язку</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="359"/>
-        <location filename="../ui/mainwindow.ui" line="372"/>
-        <source>Save solution graph</source>
-        <translation>Зберегти граф розв&apos;язку</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="362"/>
-        <location filename="../ui/mainwindow.ui" line="375"/>
-        <source>Save solution graph only</source>
-        <translation>Зберегти тільки граф розв&apos;язку</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="370"/>
-        <location filename="../ui/mainwindow.ui" line="383"/>
-        <source>&amp;Solution</source>
-        <translation>&amp;Розв&apos;язок</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="373"/>
-        <location filename="../ui/mainwindow.ui" line="386"/>
-        <source>Save solution</source>
-        <translation>Зберегти розв&apos;язок</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="376"/>
-        <location filename="../ui/mainwindow.ui" line="389"/>
-        <source>Save solution steps and graph</source>
-        <translation>Зберегти хід та граф розв&apos;язку</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="385"/>
-        <location filename="../ui/mainwindow.ui" line="398"/>
-        <source>&amp;New</source>
-        <translation>&amp;Створити</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="388"/>
-        <location filename="../ui/mainwindow.ui" line="401"/>
-        <source>New</source>
-        <translation>Створити</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="391"/>
-        <location filename="../ui/mainwindow.ui" line="404"/>
-        <source>New task</source>
-        <translation>Нове завдання</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="394"/>
-        <location filename="../ui/mainwindow.ui" line="407"/>
-        <source>Create new task</source>
-        <translation>Створити нове завдання</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="409"/>
-        <location filename="../ui/mainwindow.ui" line="422"/>
-        <source>&amp;Open...</source>
-        <translation>&amp;Відкрити...</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="412"/>
-        <location filename="../ui/mainwindow.ui" line="425"/>
-        <source>Open...</source>
-        <translation>Відкрити...</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="415"/>
-        <location filename="../ui/mainwindow.ui" line="428"/>
-        <source>Open task</source>
-        <translation>Відкрити завдання</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="418"/>
-        <location filename="../ui/mainwindow.ui" line="431"/>
-        <source>Open saved task</source>
-        <translation>Відкрити збережене завдання</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="421"/>
-        <location filename="../ui/mainwindow.ui" line="434"/>
-        <source>Ctrl+O</source>
-        <translation></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="430"/>
-        <location filename="../ui/mainwindow.ui" line="443"/>
-        <source>&amp;Preferences...</source>
-        <translation>&amp;Параметри...</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="433"/>
-        <location filename="../ui/mainwindow.ui" line="446"/>
-        <source>Preferences...</source>
-        <translation>Параметри...</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="436"/>
-        <location filename="../ui/mainwindow.ui" line="449"/>
-        <source>Application preferences</source>
-        <translation>Параметри додатку</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="448"/>
-        <location filename="../ui/mainwindow.ui" line="461"/>
-        <source>&amp;Contents</source>
-        <translation>&amp;Зміст</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="451"/>
-        <location filename="../ui/mainwindow.ui" line="464"/>
-        <source>Open help contents</source>
-        <translation>Відкрити зміст допомоги</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="463"/>
-        <location filename="../ui/mainwindow.ui" line="476"/>
-        <source>&amp;Context help</source>
-        <translation>&amp;Контекстна допомога</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="466"/>
-        <location filename="../ui/mainwindow.ui" line="479"/>
-        <source>Open context help</source>
-        <translation>Відкрити контекстну допомогу</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="475"/>
-        <location filename="../ui/mainwindow.ui" line="488"/>
-        <source>&amp;About...</source>
-        <translation>&amp;Про...</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="478"/>
-        <location filename="../ui/mainwindow.ui" line="491"/>
-        <source>About...</source>
-        <translation>Про...</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="481"/>
-        <location filename="../ui/mainwindow.ui" line="494"/>
-        <source>About application</source>
-        <translation>Про додаток</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="490"/>
-        <location filename="../ui/mainwindow.ui" line="503"/>
-        <source>E&amp;xit</source>
-        <translation>В&amp;ихід</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="493"/>
-        <location filename="../ui/mainwindow.ui" line="506"/>
-        <source>Exit application</source>
-        <translation>Вийти з додатку</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="505"/>
-        <location filename="../ui/mainwindow.ui" line="518"/>
-        <source>&amp;Task...</source>
-        <translation>&amp;Завдання...</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="508"/>
-        <location filename="../ui/mainwindow.ui" line="521"/>
-        <source>Task...</source>
-        <translation>Завдання...</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="511"/>
-        <location filename="../ui/mainwindow.ui" line="524"/>
-        <source>Save task</source>
-        <translation>Зберегти завдання</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="514"/>
-        <location filename="../ui/mainwindow.ui" line="527"/>
-        <source>Save task to file</source>
-        <translation>Зберегти завдання до файлу</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="528"/>
-        <location filename="../ui/mainwindow.ui" line="541"/>
-        <source>&amp;Autodetect</source>
-        <translation>&amp;Автовизначення</translation>
-    </message>
-    <message>
-        <location filename="../src/mainwindow.cpp" line="122"/>
-        <source>Language change</source>
-        <translation>Зміна мови</translation>
-    </message>
-    <message>
-        <location filename="../src/mainwindow.cpp" line="122"/>
-        <source>Unable to load translation language.</source>
-        <translation>Неможливо завантажити переклад.</translation>
-    </message>
-    <message>
-        <location filename="../src/mainwindow.cpp" line="189"/>
-        <source>Data error</source>
-        <translation>Помилка даних</translation>
-    </message>
-    <message>
-        <location filename="../src/mainwindow.cpp" line="189"/>
-        <source>Error in cell [Row %1; Column %2]: Invalid data format.</source>
-        <translation>Помилка у комірці  [Рядок %1; Колонка %2]: Невірний формат даних.</translation>
-    </message>
-    <message>
-        <location filename="../src/mainwindow.cpp" line="198"/>
-        <source>Solution error</source>
-        <translation>Помилка розв&apos;язку</translation>
-    </message>
-    <message>
-        <location filename="../src/mainwindow.cpp" line="198"/>
-        <source>There was an error while solving the task.</source>
-        <translation>Під час розв&apos;язання задачі виникла помилка.</translation>
-    </message>
-</context>
-<context>
     <name>SettingsDialog</name>
     <message>
Index: trunk/resources/tspsg.qrc
===================================================================
--- trunk/resources/tspsg.qrc	(revision 29)
+++ trunk/resources/tspsg.qrc	(revision 30)
@@ -7,4 +7,5 @@
   </qresource>
   <qresource prefix="/images/buttons" >
+    <file>buttons/Web.png</file>
     <file>buttons/Color.png</file>
     <file>buttons/Critical.png</file>
Index: trunk/src/mainwindow.cpp
===================================================================
--- trunk/src/mainwindow.cpp	(revision 29)
+++ trunk/src/mainwindow.cpp	(revision 30)
@@ -38,4 +38,6 @@
 #endif // Q_OS_WINCE
 	groupSettingsLanguageList = new QActionGroup(this);
+	actionSettingsLanguageEnglish->setData("en");
+	actionSettingsLanguageEnglish->setActionGroup(groupSettingsLanguageList);
 	loadLangList();
 	spinCities->setValue(settings->value("NumCities",5).toInt());
@@ -83,9 +85,12 @@
 }
 
-bool MainWindow::loadLanguage()
+bool MainWindow::loadLanguage(QString lang)
 {
 // i18n
-bool ad = settings->value("Language","").toString().isEmpty();
-QString lang = settings->value("Language",QLocale::system().name()).toString();
+bool ad = false;
+	if (lang.isEmpty()) {
+		ad = settings->value("Language","").toString().isEmpty();
+		lang = settings->value("Language",QLocale::system().name()).toString();
+	}
 static QTranslator *qtTranslator;
 	if (qtTranslator) {
@@ -95,4 +100,10 @@
 	}
 	qtTranslator = new QTranslator();
+static QTranslator *translator;
+	if (translator) {
+		qApp->removeTranslator(translator);
+		delete translator;
+	}
+	translator = new QTranslator();
 	if (lang.compare("en") && !lang.startsWith("en_")) {
 		// Trying to load system Qt library translation...
@@ -107,13 +118,5 @@
 				qtTranslator = NULL;
 			}
-	}
-	// Now let's load application translation.
-static QTranslator *translator;
-	if (translator) {
-		qApp->removeTranslator(translator);
-		delete translator;
-	}
-	translator = new QTranslator();
-	if (lang.compare("en") && !lang.startsWith("en_")) {
+		// Now let's load application translation.
 		if (translator->load(lang,"i18n"))
 			qApp->installTranslator(translator);
@@ -203,11 +206,11 @@
 {
 	// TODO: Normal about window :-)
-QString about = QString::fromUtf8("TSPSG - TSP Solver and Generator\n\
-    Copyright (C) 2007-%1 Lёppa <contacts[at]oleksii[dot]name>\n\
-Qt library versions:\n\
-    Compile time: %2\n\
-    Runtime: %3\n\
-\n\
-TSPSG is licensed under the terms of the GNU General Public License. You should have received a copy of the GNU General Public License along with TSPSG.").arg(QDate().toString("%Y"),QT_VERSION_STR,qVersion());
+QString about = QString::fromUtf8("TSPSG - TSP Solver and Generator\n");
+about += QString::fromUtf8("    Copyright (C) 2007-%1 Lёppa <contacts[at]oleksii[dot]name>\n").arg(QDate::currentDate().toString("yyyy"));
+	about += "Qt library versions:\n";
+	about += QString::fromUtf8("    Compile time: %1\n").arg(QT_VERSION_STR);
+	about += QString::fromUtf8("    Runtime: %1\n").arg(qVersion());
+	about += "\n";
+	about += "TSPSG is licensed under the terms of the GNU General Public License. You should have received a copy of the GNU General Public License along with TSPSG.";
 	QMessageBox(QMessageBox::Information,"About",about,QMessageBox::Ok,this).exec();
 }
@@ -223,9 +226,8 @@
 	if (langs.size() <= 0)
 		return;
-	menuSettingsLanguage->addSeparator();
 QAction *a;
 	for (int k = 0; k < langs.size(); k++) {
 		QFileInfo lang = langs.at(k);
-		if (!lang.completeBaseName().startsWith("qt_")) {
+		if (!lang.completeBaseName().startsWith("qt_") && lang.completeBaseName().compare("en")) {
 			a = menuSettingsLanguage->addAction(langinfo.value(lang.completeBaseName() + "/NativeName",lang.completeBaseName()).toString());
 			a->setData(lang.completeBaseName());
@@ -256,8 +258,7 @@
 			return;
 	}
-	if (loadLanguage()) {
+	if (loadLanguage(action->data().toString())) {
 		settings->setValue("Language",action->data().toString());
 		retranslateUi(this);
-	} else {
 	}
 }
Index: trunk/src/mainwindow.h
===================================================================
--- trunk/src/mainwindow.h	(revision 29)
+++ trunk/src/mainwindow.h	(revision 30)
@@ -59,5 +59,5 @@
 	CTSPModel *tspmodel;
 	QActionGroup *groupSettingsLanguageList;
-	bool loadLanguage();
+	bool loadLanguage(QString lang = "");
 	void loadLangList();
 };
Index: trunk/ui/mainwindow.ce.ui
===================================================================
--- trunk/ui/mainwindow.ce.ui	(revision 29)
+++ trunk/ui/mainwindow.ce.ui	(revision 30)
@@ -292,5 +292,11 @@
       <string extracomment="Please, append &quot; / Language&quot; when translating this string.">&amp;Language</string>
      </property>
+     <property name="icon">
+      <iconset resource="../resources/tspsg.qrc">
+       <normaloff>:/images/buttons/buttons/Web.png</normaloff>:/images/buttons/buttons/Web.png</iconset>
+     </property>
      <addaction name="actionSettingsLanguageAutodetect"/>
+     <addaction name="separator"/>
+     <addaction name="actionSettingsLanguageEnglish"/>
     </widget>
     <addaction name="menuSettingsLanguage"/>
@@ -533,4 +539,15 @@
    <property name="statusTip">
     <string>Detect language automatically based on regional settings</string>
+   </property>
+  </action>
+  <action name="actionSettingsLanguageEnglish">
+   <property name="checkable">
+    <bool>true</bool>
+   </property>
+   <property name="checked">
+    <bool>true</bool>
+   </property>
+   <property name="text">
+    <string>English</string>
    </property>
   </action>
Index: trunk/ui/mainwindow.ui
===================================================================
--- trunk/ui/mainwindow.ui	(revision 29)
+++ trunk/ui/mainwindow.ui	(revision 30)
@@ -273,5 +273,11 @@
       <string extracomment="Please, append &quot; / Language&quot; when translating this string.">&amp;Language</string>
      </property>
+     <property name="icon">
+      <iconset resource="../resources/tspsg.qrc">
+       <normaloff>:/images/buttons/buttons/Web.png</normaloff>:/images/buttons/buttons/Web.png</iconset>
+     </property>
      <addaction name="actionSettingsLanguageAutodetect"/>
+     <addaction name="separator"/>
+     <addaction name="actionSettingsLanguageEnglish"/>
     </widget>
     <addaction name="menuSettingsLanguage"/>
@@ -546,4 +552,15 @@
    <property name="statusTip">
     <string>Detect language automatically based on regional settings</string>
+   </property>
+  </action>
+  <action name="actionSettingsLanguageEnglish">
+   <property name="checkable">
+    <bool>true</bool>
+   </property>
+   <property name="checked">
+    <bool>true</bool>
+   </property>
+   <property name="text">
+    <string notr="true">English</string>
    </property>
   </action>
